<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE cpd3data>
<cpd3data version="1.0">
    <value station="_" archive="configuration_meta" variable="upload" flavors="" priority="0" type="metahash">
        <meta key="Description" type="string">Automatic file uploading and output</meta>

        <value key="Templates" type="metahash">
            <meta key="Description" type="string">Upload profile templates</meta>
            <meta key="Editor" type="hash">
                <value key="Type" type="string">TemplateName</value>
            </meta>

            <value key="" type="metahash">
                <meta key="TemplatePath" type="string">/Profiles/_</meta>
            </value>
        </value>

        <value key="Profiles" type="metahash">
            <meta key="Description" type="string">Upload profile configuration</meta>
            <meta key="Editor" type="hash">
                <value key="Type" type="string">Profile</value>
            </meta>

            <value key="" type="metahash">
                <meta key="Description" type="string">Upload configuration</meta>

                <value key="RecordEvent" type="metaboolean">
                    <meta key="Description" type="string">Record and event in the event log when the upload completes</meta>
                </value>

                <value key="Trigger" merge="@/common/sequencefilter.xml">
                    <meta key="Description" type="string">Upload trigger selection</meta>
                    <meta key="UndefinedDescription" type="string">Always regenerate</meta>
                </value>
                <value key="MaximumAge" merge="@/common/timeinterval.xml">
                    <meta key="Description" type="string">Maximum time in the past to look for the trigger</meta>
                    <meta key="UndefinedDescription" type="string">Unlimited</meta>
                </value>
                <value key="DisableReupload" type="metaboolean">
                    <meta key="Description" type="string">Disable re-uploading of already uploaded ranges when a trigger change is detected within one</meta>
                </value>
                <value key="AllowIncomplete" type="metaboolean">
                    <meta key="Description" type="string">Allow uploading of incomplete trigger ranges before any trigger is detected past the end of the range</meta>
                </value>
                <value key="DisableFill" type="metaboolean">
                    <meta key="Description" type="string">Disable uploading of filled intervals between the currently changed one and the end of the last known change</meta>
                </value>
                <value key="LatestOnly" type="metaboolean">
                    <meta key="Description" type="string">Only upload the latest interval, instead of all detected changed or filled ones</meta>
                </value>

                <value key="Interval" merge="@/common/dynamictimeinterval.xml">
                    <meta key="Description" type="string">The upload interval</meta>
                    <meta key="UndefinedDescription" type="string">Exactly the changed data</meta>
                    <meta key="Editor" type="hash">
                        <value key="AllowUndefined" type="boolean">true</value>
                    </meta>
                </value>
                <value key="Split" merge="@/common/dynamictimeinterval.xml">
                    <meta key="Description" type="string">The maximum length of an upload interval before it is split</meta>
                    <meta key="UndefinedDescription" type="string">Do not split</meta>
                    <meta key="Editor" type="hash">
                        <value key="AllowUndefined" type="boolean">true</value>
                    </meta>
                </value>
                <value key="Merge" merge="@/common/dynamictimeinterval.xml">
                    <meta key="Description" type="string">The maximum time between detected intervals that allows them to be merged into a single output interval</meta>
                    <meta key="UndefinedDescription" type="string">Do not merge</meta>
                    <meta key="Editor" type="hash">
                        <value key="AllowUndefined" type="boolean">true</value>
                    </meta>
                </value>


                <value key="Generate" type="metaarray">
                    <meta key="Description" type="string">Output file generation actions</meta>

                    <value key="Children" type="metahash">
                        <value key="Component" type="metahash">
                            <meta key="Description" type="string">Component configuration, taking precedence over a command</meta>

                            <value key="Name" type="metastring">
                                <meta key="Description" type="string">The component to execute as an action</meta>
                                <meta key="Editor" type="hash">
                                    <value key="Type" type="string">ComponentSelection</value>
                                    <value key="Mode" type="string">Action</value>
                                </meta>
                            </value>

                            <value key="Options" merge="@/common/componentoptions.xml"/>

                            <value key="IgnoreProfile" type="metaboolean">
                                <meta key="Description" type="string">Do not set the profile option to match the upload profile</meta>
                            </value>
                            <value key="IgnoreDirectory" type="metaboolean">
                                <meta key="Description" type="string">Do not set the directory option to the output temporary directory</meta>
                            </value>
                        </value>

                        <value key="Command" type="metahash">
                            <meta key="Description" type="string">External command configuration</meta>

                            <value key="AllowFailure" type="metaboolean">
                                <meta key="Description" type="string">Allow the command to exit with a failure status and still consider the generation successful</meta>
                            </value>

                            <value key="Program" merge="@/common/file.xml">
                                <meta key="Description" type="string">Program executable</meta>
                                <meta key="Editor" type="hash">
                                    <value key="Mode" type="string">Read</value>
                                </meta>
                                <meta key="Substitutions" type="hash">
                                    <value key="STATION" type="hash">
                                        <value key="Type" type="string">String</value>
                                        <value key="Description" type="string">The station being processed</value>
                                    </value>
                                    <value key="PROFILE" type="hash">
                                        <value key="Type" type="string">String</value>
                                        <value key="Description" type="string">The profile being processed</value>
                                    </value>
                                    <value key="START" type="hash">
                                        <value key="Type" type="string">Time</value>
                                        <value key="Description" type="string">The start time of the upload range</value>
                                    </value>
                                    <value key="END" type="hash">
                                        <value key="Type" type="string">Time</value>
                                        <value key="Description" type="string">The end time of the upload range</value>
                                    </value>
                                    <value key="DIRECTORY" type="hash">
                                        <value key="Type" type="string">File</value>
                                        <value key="Description" type="string">The temporary output directory</value>
                                    </value>
                                    <value key="PWD" type="hash">
                                        <value key="Type" type="string">File</value>
                                        <value key="Description" type="string">The temporary output directory</value>
                                    </value>
                                </meta>
                            </value>

                            <value key="Arguments" type="metaarray">
                                <meta key="Description" type="string">Arguments passed to the executable</meta>

                                <meta key="Children" type="metastring">
                                    <meta key="Description" type="string">Command arguments</meta>
                                    <meta key="Substitutions" type="hash">
                                        <value key="STATION" type="hash">
                                            <value key="Type" type="string">String</value>
                                            <value key="Description" type="string">The station being processed</value>
                                        </value>
                                        <value key="PROFILE" type="hash">
                                            <value key="Type" type="string">String</value>
                                            <value key="Description" type="string">The profile being processed</value>
                                        </value>
                                        <value key="START" type="hash">
                                            <value key="Type" type="string">Time</value>
                                            <value key="Description" type="string">The start time of the upload range</value>
                                        </value>
                                        <value key="END" type="hash">
                                            <value key="Type" type="string">Time</value>
                                            <value key="Description" type="string">The end time of the upload range</value>
                                        </value>
                                        <value key="DIRECTORY" type="hash">
                                            <value key="Type" type="string">File</value>
                                            <value key="Description" type="string">The temporary output directory</value>
                                        </value>
                                        <value key="PWD" type="hash">
                                            <value key="Type" type="string">File</value>
                                            <value key="Description" type="string">The temporary output directory</value>
                                        </value>
                                    </meta>
                                </meta>

                            </value>

                            <value key="AllowFailure" type="metaboolean">
                                <meta key="Description" type="string">Permit failure of the command without aborting generation</meta>
                            </value>
                        </value>
                    </value>
                </value>


                <value key="Archive" type="metahash">
                    <value key="RetryDirectory" merge="@/common/file.xml">
                        <meta key="Description" type="string">The location to store files queued for upload retry</meta>
                        <meta key="Substitutions" type="hash">
                            <value key="STATION" type="hash">
                                <value key="Type" type="string">String</value>
                                <value key="Description" type="string">The station being processed</value>
                            </value>
                            <value key="PROFILE" type="hash">
                                <value key="Type" type="string">String</value>
                                <value key="Description" type="string">The profile being processed</value>
                            </value>
                            <value key="START" type="hash">
                                <value key="Type" type="string">Time</value>
                                <value key="Description" type="string">The start time of the upload range</value>
                            </value>
                            <value key="END" type="hash">
                                <value key="Type" type="string">Time</value>
                                <value key="Description" type="string">The end time of the upload range</value>
                            </value>
                            <value key="DIRECTORY" type="hash">
                                <value key="Type" type="string">File</value>
                                <value key="Description" type="string">The temporary output directory</value>
                            </value>
                            <value key="PWD" type="hash">
                                <value key="Type" type="string">File</value>
                                <value key="Description" type="string">The temporary output directory</value>
                            </value>
                        </meta>

                    </value>

                    <value key="Completed" merge="@/common/file.xml">
                        <meta key="Description" type="string">The target name to move files to after successful upload</meta>
                        <meta key="Substitutions" type="hash">
                            <value key="STATION" type="hash">
                                <value key="Type" type="string">String</value>
                                <value key="Description" type="string">The station being processed</value>
                            </value>
                            <value key="PROFILE" type="hash">
                                <value key="Type" type="string">String</value>
                                <value key="Description" type="string">The profile being processed</value>
                            </value>
                            <value key="START" type="hash">
                                <value key="Type" type="string">Time</value>
                                <value key="Description" type="string">The start time of the upload range</value>
                            </value>
                            <value key="END" type="hash">
                                <value key="Type" type="string">Time</value>
                                <value key="Description" type="string">The end time of the upload range</value>
                            </value>
                            <value key="DIRECTORY" type="hash">
                                <value key="Type" type="string">File</value>
                                <value key="Description" type="string">The temporary output directory</value>
                            </value>
                            <value key="PWD" type="hash">
                                <value key="Type" type="string">File</value>
                                <value key="Description" type="string">The temporary output directory</value>
                            </value>
                            <value key="INPUT" type="hash">
                                <value key="Type" type="string">File</value>
                                <value key="Description" type="string">The original input file name</value>
                            </value>
                            <value key="UPLOAD" type="hash">
                                <value key="Type" type="string">File</value>
                                <value key="Description" type="string">The original input file name</value>
                            </value>
                            <value key="SOURCE" type="hash">
                                <value key="Type" type="string">File</value>
                                <value key="Description" type="string">The original input file name</value>
                            </value>
                            <value key="FILE" type="hash">
                                <value key="Type" type="string">String</value>
                                <value key="Description" type="string">The original upload file name without any path information</value>
                            </value>
                        </meta>

                    </value>
                </value>

                <value key="Transfer" merge="@/transfer/upload.xml">
                    <value key="Batch" type="metaboolean">
                        <meta key="Description" type="string">Upload all files in batch mode, instead of one upload per file</meta>
                    </value>
                    <value key="AbortOnFailure" type="metaboolean">
                        <meta key="Description" type="string">Abort the entire upload on any detected failure</meta>
                    </value>
                    <value key="HaltOnFailure" type="metaboolean">
                        <meta key="Description" type="string">Stop uploading subsequent files on failure</meta>
                    </value>
                </value>
            </value>
        </value>

    </value>
</cpd3data>
